//Script By: FaTDoG
//Version 1.0
datablock fxDTSBrickData(brickJailSpawnData : brickSpawnPointData)
{
   uiName = "Jail Spawn";
};

function serverCmdJail(%client, %victimName, %time)
{
   if(!%client.isAdmin && !%client.isSuperAdmin)
   {
      centerPrint(%client, "You are not an admin.", 3);
      return;
   }

   %victim = findClientByName(%victimName);
   if(!%victim || !isObject(%victim.player))
   {
      centerPrint(%client, "Unable to find player: \c6" @ %victimName @ "\c0.", 3);
      return;
   }

   %brickGroup = %client.brickGroup;
   for(%i = 0; %i < %brickGroup.getCount(); %i++)
   {
      %jail = %brickGroup.getObject(%i);

      if(%jail.dataBlock $= "brickJailSpawnData")
         break;
   }

   if(%jail.dataBlock !$= "brickJailSpawnData")
   {
      centerPrint(%client, "No jail spawn brick was found!", 3);
      return;
   }

   %player = %victim.player;
   %player.setTransform(%jail.getPosition() SPC getWords(%player.getTransform(), 3, 6));

   %time = mClamp(%time, 1, 1440);
   messageAll("", "\c6" @ %victimName @ " \c0was jailed for \c6" @ %time @ " \c0minute(s).");

   %victim.releaseSchedule = schedule(%time * 60000, 0, "releaseClient", %victim);
   %victim.isJailed = true;

   for(%i = 0; %i < %player.dataBlock.maxTools; %i++)
   {
      %player.oldTool[%i] = %player.tool[%i];
      %player.tool[%i] = 0;
      messageClient(%victim, 'MsgItemPickup', "", %i, 0);
   }
}

function serverCmdRelease(%client, %victimName)
{
   if(!%client.isAdmin && !%client.isSuperAdmin)
   {
      centerPrint(%client, "You are not an admin.", 3);
      return;
   }

   %victim = findClientByName(%victimName);
   if(!%victim || !isObject(%victim.player))
   {
      centerPrint(%client, "Unable to find player: \c6" @ %victimName @ "\c0.", 3);
      return;
   }

   releaseClient(%victim);
}

function releaseClient(%client)
{
   %player = %client.player;
   if(!%client.isJailed || !isObject(%player))
      return;

   for(%i = 0; %i < %player.dataBlock.maxTools; %i++)
   {
      %player.tool[%i] = %player.oldTool[%i];
      messageClient(%client, 'MsgItemPickup', "", %player.oldTool[%i], 0);
      %player.oldTool[%i] = "";
   }

   %player.setTransform(pickSpawnPoint());
   cancel(%client.releaseSchedule);
   %client.isJailed = false;

   messageAll("", "\c6" @ %client.name @ " \c0was released from jail.");
}

package Jail
{
   function serverCmdSuicide(%client)
   {
      if(%client.isJailed)
         return;

      Parent::serverCmdSuicide(%client);
   }
   
};
activatePackage(Jail);
